



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>以 BZOJ 2002 为例学习有根树LCT(Link-Cut Tree)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">以 BZOJ 2002 为例学习有根树LCT(Link-Cut Tree)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 22:14:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>以<a href="http://www.lydsy.com/JudgeOnline/problem.php?id=2002" rel="external nofollow noreferrer">BZOJ 2002 弹飞绵羊</a>为例学习有根树LCT(Link-Cut Tree)</h1>
<hr>
<blockquote><p>注：本文非常简单，只涉及有根树LCT，对于无根树，LCT还有几个本文没有提到的操作，以后慢慢更新 =v=</p></blockquote>
<h2>知识储备</h2>
<ul><li>[x]  splay</li>
<li>[x] 树链剖分</li></ul>
<h2>题意</h2>
<p>有一棵\(n\)个节点的有根树，动态修改父子关系（保证仍是一棵有根树），并询问某节点深度。</p>
<h2>题解</h2>
<p>这是一道LCT(Link-Cut Tree)的模板题。</p>
<p>Link-Cut Tree （又）是Tarjan发明的一种算法，可以解决一类动态树问题。“动态树问题”就是像本题这种，随时修改树的结构的问题。</p>
<p>LCT在思想上有些类似于树链剖分。</p>
<p>回顾一下树剖：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1129536/201712/1129536-20171220091919693-198862609.png"></p>
<p>在树剖中，我们把边分为重边和轻边两种，重边相连形成了重链，而重链可以用线段树维护。</p>
<p>美中不足的是，线段树无法完成“动态修改”的需要。那么什么数据结构最灵活，能随时断开/连接呢？那当然是——splay啦。</p>
<p>所以，LCT就是用好多棵splay平衡树来维护原树上的每条“实链”（类似树剖的“重链”）。</p>
<p>具体是如何维护的呢？可以看这幅图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1129536/201712/1129536-20171220104301850-1905204889.png"></p>
<p>左图是原树，右图是我们建出的splay树。</p>
<p>左图中的每一条实链都对应着右图中一棵“完整的”（不带“箭头”的）平衡树，如（1，2，3）、（4，5）、（6）各自组成一棵平衡树。每棵完整的平衡树都把节点在原树中的深度作为关键字，例如4比5深度小，所以是5的左儿子；3比1深度大，所以是1的右儿子。当然，身为splay，右图不是左图对应的唯一平衡树，还有很多种可能的合法平衡树。</p>
<p>而左图上的每一条虚边(u, v)，则使用了一种“单向边”来维护：设u是父亲、v是儿子，则在右图中，v所在的平衡树的<strong>根节点</strong>“认”u所在的平衡树的<strong>根节点</strong>为父亲，而反过来，父亲却不认儿子。这种关系在右图中用单向的箭头表示了。例如，在原图中，(1, 4)是一条虚边，4所在的平衡树的根节点是5，1所在的平衡树的根节点是1，所以右图中fa[5] = 1，而1却不认为5是它的儿子。</p>
<p>好的，现在你对LCT如何实现有了个初步的印象了！那么接下来，我们逐个学习LCT涉及到的操作。</p>
<h3>操作1：Access</h3>
<p>Access操作是所有LCT操作的基础！<code>Access(u)</code>会把根节点到u路径上的所有边都变成“实边”，使得u和根节点处于一棵完整平衡树中。</p>
<p>代码实现：</p>
<pre class="prettyprint linenums"><code>void access(int u){<br />
    int v = 0; //一开始v是空节点，其余时刻v都是要与u连接的小平衡树的根节点<br />
    while(u){<br />
        splay(u); //将u在旋至它所在的平衡树的根节点<br />
        rs[u] = v; //因为v深度更大，所以让v作为u的右儿子<br />
        upt(u); //修改儿子后，莫忘调用单节点更新函数<br />
        v = u, u = fa[u];<br />
    }<br />
}<br />
</code></pre>
<p>是不是不算很难呐~</p>
<h3>操作2：Cut</h3>
<p>顾名思义，Cut就是切断原树中的一条边。下面代码中，<code>Cut(u)</code>表示切断u和父亲的连边。这道题是有根树，非常简单——先<code>Access(u)</code>，使u和跟节点处在同一平衡树中，然后完全切断u向fa[u]连的那条边，即使得“父子互不相认”即可。</p>
<pre class="prettyprint linenums"><code>void cut(int u){<br />
    access(u);<br />
    splay(u);<br />
    fa[ls[u]] = 0, ls[u] = 0;<br />
    upt(u);<br />
}<br />
</code></pre>
<h3>操作3：Link</h3>
<p>顾名思义，Link就是绿帽子林克将两个节点连到一起，即在原树中加边的操作。</p>
<p>这道题是有根树，有根树中Link操作非常简单：<code>Link(u, v)</code>表示把u作为v的儿子——那么直接令<code>fa[u] = v</code>即可。</p>
<pre class="prettyprint linenums"><code>void link(int u, int v){<br />
    cut(u);void cut(int u){<br />
    access(u);<br />
    splay(u);<br />
    fa[ls[u]] = 0, ls[u] = 0;<br />
    upt(u);<br />
}<br />
    fa[u] = v;<br />
}<br />
</code></pre>
<p>有根树LCT涉及的基本操作只有这三条！只要写个splay、再写这三个函数，<a href="http://www.lydsy.com/JudgeOnline/problem.php?id=2002" rel="external nofollow noreferrer">BZOJ 2002 弹飞绵羊</a>这道题就很好写啦！</p>
<p>附上我的代码（大部分是Copycat<a href="http://oi.self-jqe.win/?p=257" rel="external nofollow noreferrer">企鹅学长</a>的……）</p>
<pre class="prettyprint linenums"><code>#include &lt;cstdio&gt;<br />
#include &lt;cmath&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
using namespace std;<br />
typedef long long ll;<br />
#define enter putchar('\n')<br />
#define space putchar(' ')<br />
template &lt;class T&gt;<br />
void read(T &amp;x){<br />
    char c;<br />
    bool op = 0;<br />
    while(c = getchar(), c &gt; '9' || c &lt; '0')<br />
	if(c == '-') op = 1;<br />
    x = c - '0';<br />
    while(c = getchar(), c &gt;= '0' &amp;&amp; c &lt;= '9')<br />
	x = x * 10 + c - '0';<br />
    if(op) x = -x;<br />
}<br />
template &lt;class T&gt;<br />
void write(T x){<br />
    if(x &lt; 0) putchar('-'), x = -x;<br />
    if(x &gt;= 10) write(x / 10);<br />
    putchar('0' + x % 10);<br />
}<br />
const int N = 200005;<br />
int n, m, ta, tb;<br />
int fa[N], ls[N], rs[N], sze[N];<br />
#define isroot(u) (ls[fa[u]] != (u) &amp;&amp; rs[fa[u]] != (u))<br />
#define which(u) (ls[fa[u]] == (u))<br />
void upt(int u){<br />
    sze[u] = sze[ls[u]] + sze[rs[u]] + 1;<br />
}<br />
void rotate(int u){<br />
    int v = fa[u], w = fa[v], b = which(u) ? rs[u]: ls[u];<br />
    if(!isroot(v)) which(v) ? ls[w] = u: rs[w] = u;<br />
    which(u) ? (ls[v] = b, rs[u] = v): (rs[v] = b, ls[u] = v);<br />
    fa[u] = w, fa[v] = u;<br />
    if(b) fa[b] = v;<br />
    upt(v), upt(u);<br />
}<br />
void splay(int u){<br />
    while(!isroot(u)){<br />
	if(!isroot(fa[u])){<br />
	    if(which(u) == which(fa[u])) rotate(fa[u]);<br />
	    else rotate(u);<br />
	}<br />
	rotate(u);<br />
    }<br />
}<br />
void access(int u){<br />
    int v = 0;<br />
    while(u){<br />
	splay(u);<br />
	rs[u] = v;<br />
	upt(u);<br />
	v = u, u = fa[u];<br />
    }<br />
}<br />
void cut(int u){<br />
    access(u);<br />
    splay(u);<br />
    fa[ls[u]] = 0, ls[u] = 0;<br />
    upt(u);<br />
}<br />
void link(int u, int v){<br />
    cut(u);<br />
    fa[u] = v;<br />
}<br />
int main(){<br />
    read(n);<br />
    for(int i = 1; i &lt;= n; i++)<br />
	read(ta), sze[i] = 1, fa[i] = ta + i &gt; n ? 0 : ta + i;<br />
    read(m);<br />
    while(m--){<br />
	read(ta);<br />
	if(ta == 1){<br />
	    read(ta), ta++;<br />
	    access(ta);<br />
	    splay(ta);h<br />
	    write(sze[ls[ta]] + 1), enter;<br />
	}<br />
	else{<br />
	    read(ta), read(tb), ta++;<br />
	    link(ta, ta + tb &gt; n ? 0 : ta + tb);<br />
	}<br />
    }<br />
    return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvedoo9.html">Linux文件和目录权限详细讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rxxgm9.html">java-Filter</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m36no9.html">JSP&sol;SERVLET入门教程－－Servlet 使用入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4e4l39.html">ThinkPHP 学习笔记 &lpar; 五 &rpar; 数据验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1wd79.html">编写一个JAVA小程序取得IP地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwddk238.html">XSS防御篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjjywk9.html">jmeter 建立一个网络服务的测试计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydm3dgq.html">C&plus;&plus;中把string转成char</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1dn4x9.html">phpcms自定义分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v1jzq.html">通过Jexus 部署 dotnetcore</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdk3rk9.html">测试部署nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdyw0z9.html">【学习笔记】Hibernate HQL连接查询和数据批处理 （Y2-1-7）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950v70v8.html">directdraw显示yuv422&lpar;yuy2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zony5nq.html">android的Binder通信机制java层浅谈-android学习之旅（88）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o0ol18.html">Connection reset by peer原理解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j3v2jq.html">CentOS配置多公网</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7pg59.html">：策略模式--Duck</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o675j8.html">winform中datagridview刷新后的排序记忆</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4n511q.html">JAVA框架Struts2  servlet API</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4n2vxq.html">【Java框架型项目从入门到装逼】第十一节  用户新增之把数据传递到后台</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rnz72rq.html">HUE的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmjdpg9.html">Exp1 PC平台逆向破解&lpar;5&rpar;M</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gp1rv49.html">Nuget包CommonServiceLocator从1&period;0&period;3升级到2&period;0&period;4时MvvmLight的ViewModelLocator初始化SimpleIoc&period;Default格式不匹配问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1ep619.html">Retry模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/963j4449.html">python 回溯法 子集树模板 系列 &mdash;&mdash; 10、m着色问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4n2o5q.html">tkinter 对键盘和鼠标事件的处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7exjkj9.html">模拟赛 sutoringu</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvwx1xq.html">【python笔记】使用matplotlib&comma;pylab进行python绘图</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2wjl08.html">Jq&lowbar;浏览器兼容性及其浏览器版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kde6lq.html">Windows Server 2003出现Directory Listing Denied This Virtual Directory does not allow contents to be listed&period;的解决方案</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
